use szun::*;

fn hex_str(data:Vec<u8>) -> String
{
    fn nibble(byte:u8) -> char
    {
        if byte < 10 {
            char::from_u32('0' as u32 + byte as u32).unwrap_or('?')
        } else {
            char::from_u32('a' as u32 + (byte as u32 - 10)).unwrap_or('?')
        }
    }

    let mut result = String::with_capacity(data.len() * 2);
    for byte in data {
        result.push(nibble((byte >> 4) & 0x0F));
        result.push(nibble(byte & 0x0F));
    }
    result
}

fn main() {
    let mut list = List::<Any>::new();
    list.push(&Natural::new().with(10));
    list.push(&Natural::new().with(20));
    list.push(&Integer::new().with(-1));

    println!("{}", hex_str(list.encode()));
}
