use crate::{
    prelude::*,
    runtime,
    Var,
};

pub struct Any {
    address:Ref,
}
impl Any {
    pub fn type_id(&self) -> usize { self.address.type_id() }
}
impl SzunType for Any {
    fn type_id() -> usize { Var::type_id() }

    fn compatible<R: SzunType>(&self, _:&R) -> bool { false }

    fn __to_ref(&self) -> Ref { self.address.clone() }
    fn __from_ref(refr:Ref) -> Self { Self { address:refr } }
}
impl Clone for Any {
    fn clone(&self) -> Self
    {
        Self::__from_ref(unsafe {runtime::clone(self.address.clone())})
    }
}
impl Drop for Any {
    fn drop(&mut self)
    {
        unsafe {runtime::release(self.address.clone())};
    }
}
