use crate::{
    prelude::*,
    runtime::const_clone,
};

pub struct Const<T: SzunType> {
    data:T,
}
impl<T: SzunType> Const<T> {
    pub fn from(data:&T) -> Self
    // Converts an object to a memory-continuous, fixed-size block.
    //
    {
        Self {
            data:T::__from_ref(unsafe {const_clone(data.__to_ref())}),
        }
    }

    pub fn get(&self) -> &T
    {
        &self.data
    }
}
