use crate::{
    prelude::*,
    types,
};

pub struct Null { }
impl Null {
    pub fn new() -> Self { Self { } }
}
pub fn null() -> Null { Null::new() }

impl SzunType for Null {
    fn type_id() -> usize { types::TYPE_NULL }

    fn encode(&self) -> Vec<u8>
    {
        Vec::new()
    }

    fn decode(&mut self, _:&Vec<u8>, _:&mut usize) -> Result<(), SzunError>
    {
        Ok(())
    }

    fn compatible<T: SzunType>(&self, _:&T) -> bool { false }

    fn __to_ref(&self) -> Ref { Ref { class:0, address:0 } }
    fn __from_ref(_:Ref) -> Self { Self { } }
}
impl Clone for Null {
    fn clone(&self) -> Self { Null::new() }
}
impl TryFrom<Any> for Null {
    type Error = SzunError;
    fn try_from(_: Any) -> Result<Self, Self::Error> { Ok(Self { }) }
}
impl Into<Any> for Null { fn into(self) -> Any { Any::__from_ref(Ref::null()) } }
