use crate::{
    prelude::*,
    runtime,
    types,
};

pub struct Schema {
    address:Ref,
}
impl Schema {
    pub fn new() -> Self
    {
        Self { address:unsafe {runtime::acquire(Self::type_id())} }
    }
}
impl SzunType for Schema {
    fn type_id() -> usize { unsafe {runtime::type_outer(0, types::TYPE_NATURAL)} }

    fn compatible<T: SzunType>(&self, _:&T) -> bool { false }

    fn __to_ref(&self) -> Ref { self.address.clone() }
    fn __from_ref(refr:Ref) -> Self { Self { address:refr } }
}
impl Clone for Schema {
    fn clone(&self) -> Self
    {
        Self::__from_ref(unsafe {runtime::clone(self.address.clone())})
    }
}
impl TryFrom<Any> for Schema {
    type Error = SzunError;
    fn try_from(obj: Any) -> Result<Self, Self::Error>
    {
        if obj.type_id() == Self::type_id() {
            Ok(Self::__from_ref(obj.__to_ref()))
        } else { Err(SzunError::MismatchedType) }
    }
}
impl Into<Any> for Schema { fn into(self) -> Any { Any::__from_ref(self.address.clone()) } }
impl Drop for Schema {
    fn drop(&mut self)
    {
        unsafe {runtime::release(self.address.clone())};
    }
}
