mod reference; pub use reference::Ref;
mod error; pub use error::SzunError;
pub use crate::Any;

pub trait SzunType : Clone + TryFrom<Any> + Into<Any> {
    fn type_id() -> usize;
    fn to_any(self) -> Any { self.into() }

    fn tag(&self) -> Vec<u8>
    {
        let mut data = Vec::<u8>::new();
        let mut current = Self::type_id();

        while current != 0 {
            data.append(&mut Vec::<u8>::new());
            current = 0;
        }

        data
    }

    fn encode(&self) -> Vec<u8> { crate::encode::encode(self.__to_ref()) }
    fn encode_data(&self) -> Vec<u8> { crate::encode::encode_data(self.__to_ref()) }

    fn decode(&mut self, _:&Vec<u8>, _:&mut usize) -> Result<(), SzunError>
    {
        Err(SzunError::NotImplemented)
    }

    fn compatible<T: SzunType>(&self, refr:&T) -> bool;

    fn __to_ref(&self) -> Ref;
    fn __from_ref(refr:Ref) -> Self;
}
