#include "lib.h"

size_t array_length(Reference addr)
{
    return type_innerkey(addr.type);
}

Reference array_cell(Reference addr, size_t index)
{
    Reference result {0};
    size_t lnode = type_inner(addr.type);
    size_t length = type_key(lnode);
    size_t type = type_inner(lnode);
    size_t offset = type_size(type);

    // validate for overflow
    if(addr.address != nullptr && offset > 0 && index < length) {
        result.type = type;
        result.address = addr.address + (offset * index);
    }
    return result;
}


extern "C" Reference array_at(Reference addr, size_t index)
{
    Reference result {0};
    Reference cell = array_cell(addr, index);
    if(cell.address != nullptr) {
        //if(type_key(cell.type) == Type::TYPE_VARYING) {
        //    result = var_get(cell);
        //}
        //else {
            result = cell;
        //}
    }
    return refr_make_temporary(result);
}

extern "C" void array_set(Reference addr, size_t index, Reference source)
{
    Reference cell = array_cell(addr, index);
    if(cell.address != nullptr) {
        if(type_key(cell.type) == Type::TYPE_VARYING) {
            var_set(cell, source);
        }
        else {
            copy(cell, source);
        }
    }
}
