#pragma once

#include <cstdint>
#include <cstdlib>
#include <cstring>

#include "util/rawlist/rawlist.h"
#include "util/sparselist.h"
#include "util/pool.h"
#include "util/type.h"
#include "util/typetree.h"
#include "util/nametree.h"

extern "C" struct Str {
    uint8_t* bytes;
    size_t length;
};

extern TypeTree DB_TYPE;
extern NameTree DB_NAME;
extern SparseList<Type::SchemaBinding> DB_SCHEMA;
extern Pool<Reference> DB_REFERENCE;

extern "C" void test();

#include "header/refr.h"
#include "header/type.h"
#include "header/name.h"
#include "header/memory.h"

#include "header/implement/boolean.h"

#include "header/implement/natural.h"
#include "header/implement/integer.h"
#include "header/implement/significant.h"

#include "header/implement/block.h"
#include "header/implement/sequence.h"

#include "header/implement/var.h"
#include "header/implement/array.h"
#include "header/implement/list.h"
#include "header/implement/sparse.h"

#include "header/implement/record.h"
#include "header/implement/schema.h"
