const size_t MASK_TEMPORARY = (size_t(-1) >> 1) + 1;

Reference refr_resolve(Reference addr)
// Converts a reference into a reference of the contained address.
//
{
    Reference result = addr;
    if(result.type & ~MASK_TEMPORARY == Type::TYPE_NULL) {
        if(result.address != nullptr) {
            result = *reinterpret_cast<Reference*>(result.address);
        }
        else {
            result = Reference {0};
        }
    }
    return result;
}

Reference refr_make_temporary(Reference refr)
{
    refr.type |= MASK_TEMPORARY;
    return refr;
}

bool refr_is_temporary(Reference refr)
{
    return (refr.type & MASK_TEMPORARY) != 0;
}

Reference refr_restore(Reference refr)
{
    refr.type &= ~MASK_TEMPORARY;
    return refr;
}
