use crate::*;

#[test]
fn sequence_initialize()
{
    let value = Sequence::new();
    assert_eq!(0, value.size(), "Sequence::new() has length 0.");
}

#[test]
fn sequence_set_get_raw()
{
    let mut value = Sequence::new();
    value.set_raw(vec![0, 1, 2, 3, 2, 1]);
    assert_eq!(6, value.size(), "Sequence.set_raw([0,1,2,3,2,1]) has length 6.");
    assert_eq!(vec![0,1,2,3,2,1], value.get_raw(), "Sequence.set_raw([0,1,2,3,2,1]) produces value [0,1,2,3,2,1].");
}

#[test]
fn sequence_set_get_str()
{
    let mut value = Sequence::new();
    value.set("hello");
    assert_eq!(5, value.size(), "Sequence.set(hello) has length 5.");
    assert_eq!(String::from("hello"), value.get(), "Sequence.set(hello) produces value hello.");
}
